<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::entropy_decoder_model_kernel_2&lt; alphabet_size, entropy_decoder, cc, ccbig &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1entropy__decoder__model__kernel__2.html">entropy_decoder_model_kernel_2</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1entropy__decoder__model__kernel__2-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::entropy_decoder_model_kernel_2&lt; alphabet_size, entropy_decoder, cc, ccbig &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:ac5bbf18889e65523e7f62c9b5043e029"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classdlib_1_1entropy__decoder.html">entropy_decoder</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__decoder__model__kernel__2.html#ac5bbf18889e65523e7f62c9b5043e029">entropy_decoder_type</a></td></tr>
<tr class="separator:ac5bbf18889e65523e7f62c9b5043e029"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a0481f56165fffe3303764425c264124f"><td class="memItemLeft" align="right" valign="top"><a id="a0481f56165fffe3303764425c264124f"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>entropy_decoder_model_kernel_2</b> (<a class="el" href="classdlib_1_1entropy__decoder.html">entropy_decoder</a> &amp;coder)</td></tr>
<tr class="separator:a0481f56165fffe3303764425c264124f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a17ebfa494da10c2269a7433eee9bbefe"><td class="memItemLeft" align="right" valign="top"><a id="a17ebfa494da10c2269a7433eee9bbefe"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a17ebfa494da10c2269a7433eee9bbefe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a24b92d3b5766af045f12ffbe3b48bbb3"><td class="memItemLeft" align="right" valign="top"><a id="a24b92d3b5766af045f12ffbe3b48bbb3"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>decode</b> (unsigned long &amp;symbol)</td></tr>
<tr class="separator:a24b92d3b5766af045f12ffbe3b48bbb3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abd0be89652b3e8ecf6485d175f0aeb51"><td class="memItemLeft" align="right" valign="top"><a id="abd0be89652b3e8ecf6485d175f0aeb51"></a>
<a class="el" href="classdlib_1_1entropy__decoder.html">entropy_decoder</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>get_entropy_decoder</b> ()</td></tr>
<tr class="separator:abd0be89652b3e8ecf6485d175f0aeb51"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a12933f1a5cc4d795e79e7f50b786d18d"><td class="memItemLeft" align="right" valign="top"><a id="a12933f1a5cc4d795e79e7f50b786d18d"></a>
static unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>get_alphabet_size</b> ()</td></tr>
<tr class="separator:a12933f1a5cc4d795e79e7f50b786d18d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a6ffda527ae4117a58cc7d0d233d841b1"><td class="memItemLeft" align="right" valign="top"><a id="a6ffda527ae4117a58cc7d0d233d841b1"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>entropy_decoder_model_kernel_2</b> (<a class="el" href="classdlib_1_1entropy__decoder__model__kernel__2.html">entropy_decoder_model_kernel_2</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__decoder.html">entropy_decoder</a>, cc, ccbig &gt; &amp;)</td></tr>
<tr class="separator:a6ffda527ae4117a58cc7d0d233d841b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a4e0860aa013a41ef3eea2b0290ab0a"><td class="memItemLeft" align="right" valign="top"><a id="a0a4e0860aa013a41ef3eea2b0290ab0a"></a>
<a class="el" href="classdlib_1_1entropy__decoder__model__kernel__2.html">entropy_decoder_model_kernel_2</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__decoder.html">entropy_decoder</a>, cc, ccbig &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1entropy__decoder__model__kernel__2.html">entropy_decoder_model_kernel_2</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__decoder.html">entropy_decoder</a>, cc, ccbig &gt; &amp;)</td></tr>
<tr class="separator:a0a4e0860aa013a41ef3eea2b0290ab0a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a8e04cbad36149ce2235e4cdbf5774062"><td class="memItemLeft" align="right" valign="top"><a id="a8e04cbad36149ce2235e4cdbf5774062"></a>
<a class="el" href="classdlib_1_1entropy__decoder.html">entropy_decoder</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>coder</b></td></tr>
<tr class="separator:a8e04cbad36149ce2235e4cdbf5774062"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af14361ab950467d39083899ecb252a3b"><td class="memItemLeft" align="right" valign="top"><a id="af14361ab950467d39083899ecb252a3b"></a>
cc::global_state_type&#160;</td><td class="memItemRight" valign="bottom"><b>gs</b></td></tr>
<tr class="separator:af14361ab950467d39083899ecb252a3b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a29b478e73fd4dcab17770e84d0134512"><td class="memItemLeft" align="right" valign="top"><a id="a29b478e73fd4dcab17770e84d0134512"></a>
ccbig::global_state_type&#160;</td><td class="memItemRight" valign="bottom"><b>gsbig</b></td></tr>
<tr class="separator:a29b478e73fd4dcab17770e84d0134512"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8c8316fca65a87a217f1b9546fcf6e4c"><td class="memItemLeft" align="right" valign="top"><a id="a8c8316fca65a87a217f1b9546fcf6e4c"></a>
cc&#160;</td><td class="memItemRight" valign="bottom"><b>order_0</b></td></tr>
<tr class="separator:a8c8316fca65a87a217f1b9546fcf6e4c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a26331ebec5dc14966047977c4387a9d8"><td class="memItemLeft" align="right" valign="top"><a id="a26331ebec5dc14966047977c4387a9d8"></a>
ccbig *&#160;</td><td class="memItemRight" valign="bottom"><b>order_1</b> [alphabet_size]</td></tr>
<tr class="separator:a26331ebec5dc14966047977c4387a9d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae28b43f328421199d52d3a3762399343"><td class="memItemLeft" align="right" valign="top"><a id="ae28b43f328421199d52d3a3762399343"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>previous_symbol</b></td></tr>
<tr class="separator:ae28b43f328421199d52d3a3762399343"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="ac5bbf18889e65523e7f62c9b5043e029"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac5bbf18889e65523e7f62c9b5043e029">&#9670;&nbsp;</a></span>entropy_decoder_type</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;unsigned long alphabet_size, typename entropy_decoder, typename cc, typename ccbig&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="classdlib_1_1entropy__decoder.html">entropy_decoder</a> <a class="el" href="classdlib_1_1entropy__decoder__model__kernel__2.html">dlib::entropy_decoder_model_kernel_2</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__decoder.html">entropy_decoder</a>, cc, ccbig &gt;::<a class="el" href="classdlib_1_1entropy__decoder__model__kernel__2.html#ac5bbf18889e65523e7f62c9b5043e029">entropy_decoder_type</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">REQUIREMENTS ON cc
    cc is an implementation of conditioning_class/conditioning_class_kernel_abstract.h
    cc::get_alphabet_size() == alphabet_size+1
    this will be used for the order-0 context

REQUIREMENTS ON ccbig
    ccbig is an implementation of conditioning_class/conditioning_class_kernel_abstract.h
    ccbig::get_alphabet_size() == alphabet_size+1
    this will be used for the order-1 context

INITIAL VALUE
    Initially this object's finite context model is empty
    previous_symbol == 0

CONVENTION
    &amp;get_entropy_decoder() == coder
    &amp;order_0.get_global_state() == &amp;gs
    &amp;order_1[i]-&gt;get_global_state() == &amp;gsbig


    This is an order-1-0 model. The last symbol in the order-0 and order-1
    context is an escape into the lower context.        

    previous_symbol == the last symbol seen
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="entropy__decoder__model__kernel__2_8h_source.html">entropy_decoder_model_kernel_2.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
